;file lib_threads.inc

vp0_thread = -1
vp1_thread = -1
vp2_thread = -1
vp3_thread = -1
vp4_thread = -1
vp5_thread = -1
vp6_thread = -1
vp7_thread = -1
vp8_thread = -1
vp9_thread = -1
vp10_thread = -1
vp11_thread = -1
vp12_thread = -1
vp13_thread = -1
vp14_thread = -1
vp15_thread = -1

lib_thread_jumptable	macro
		org	code
if THREADS > 1
expand
do_thread
noexpand
if THREADS > 8
expand
		and	w,#$0F
noexpand
else
  if THREADS > 4
expand
		and	w,#$07
noexpand
  else
    if THREADS > 2
expand
		and	w,#$03
noexpand
    else
      if THREADS > 1
expand
		and	w,#$01
noexpand
      endif
    endif
  endif
endif
expand
		add	pc,w
		jmp	isr0_thread
noexpand
if THREADS > 1
expand
		jmp	isr1_thread
noexpand
endif
if THREADS > 2
expand
		jmp	isr2_thread
		jmp	isr3_thread
noexpand
endif
if THREADS > 4
expand
		jmp	isr4_thread
		jmp	isr5_thread
		jmp	isr6_thread
		jmp	isr7_thread
noexpand
endif
if THREADS > 8
expand
		jmp	isr8_thread
		jmp	isr9_thread
		jmp	isr10_thread
		jmp	isr11_thread
		jmp	isr12_thread
		jmp	isr13_thread
		jmp	isr14_thread
		jmp	isr15_thread
noexpand
endif
endif
code		=	$
endm

_lib_make_isr_thread	macro	nr
expand
isr??nr??_thread
noexpand
ifdef vp0_bank
  if vp0_thread & (1<<nr) != 0
expand
		call	vp0_isr
noexpand
  endif
endif
ifdef vp1_bank
  if vp1_thread & (1<<nr) != 0
expand
		call	vp1_isr
noexpand
  endif
endif
ifdef vp2_bank
  if vp2_thread & (1<<nr) != 0
expand
		call	vp2_isr
noexpand
  endif
endif
ifdef vp3_bank
  if vp3_thread & (1<<nr) != 0
expand
		call	vp3_isr
noexpand
  endif
endif
ifdef vp4_bank
  if vp4_thread & (1<<nr) != 0
expand
		call	vp4_isr
noexpand
  endif
endif
ifdef vp5_bank
  if vp5_thread & (1<<nr) != 0
expand
		call	vp5_isr
noexpand
  endif
endif
ifdef vp6_bank
  if vp6_thread & (1<<nr) != 0
expand
		call	vp6_isr
noexpand
  endif
endif
ifdef vp7_bank
  if vp7_thread & (1<<nr) != 0
expand
		call	vp7_isr
noexpand
  endif
endif
ifdef vp8_bank
  if vp8_thread & (1<<nr) != 0
expand
		call	vp8_isr
noexpand
  endif
endif
ifdef vp9_bank
  if vp9_thread & (1<<nr) != 0
expand
		call	vp9_isr
noexpand
  endif
endif
ifdef vp10_bank
  if vp10_thread & (1<<nr) != 0
expand
		call	vp10_isr
noexpand
  endif
endif
ifdef vp11_bank
  if vp11_thread & (1<<nr) != 0
expand
		call	vp11_isr
noexpand
  endif
endif
ifdef vp12_bank
  if vp12_thread & (1<<nr) != 0
expand
		call	vp12_isr
noexpand
  endif
endif
ifdef vp13_bank
  if vp13_thread & (1<<nr) != 0
expand
		call	vp13_isr
noexpand
  endif
endif
ifdef vp14_bank
  if vp14_thread & (1<<nr) != 0
expand
		call	vp14_isr
noexpand
  endif
endif
ifdef vp15_bank
  if vp15_thread & (1<<nr) != 0
expand
		call	vp15_isr
noexpand
  endif
endif
expand
		jmp	isr_thread_end
noexpand
endm

lib_isr_thread	macro
if THREADS <= 1
  vp0_thread = 0
  vp1_thread = 0
  vp2_thread = 0
  vp3_thread = 0
  vp4_thread = 0
  vp5_thread = 0
  vp6_thread = 0
  vp7_thread = 0
  vp8_thread = 0
  vp9_thread = 0
  vp10_thread = 0
  vp11_thread = 0
  vp12_thread = 0
  vp13_thread = 0
  vp14_thread = 0
  vp15_thread = 0
endif
ifdef vp0_bank
  if vp0_thread == 0
expand
		call	vp0_isr
noexpand
  endif
endif
ifdef vp1_bank
  if vp1_thread == 0
expand
		call	vp1_isr
noexpand
  endif
endif
ifdef vp2_bank
  if vp2_thread == 0
expand
		call	vp2_isr
noexpand
  endif
endif
ifdef vp3_bank
  if vp3_thread == 0
expand
		call	vp3_isr
noexpand
  endif
endif
ifdef vp4_bank
  if vp4_thread == 0
expand
		call	vp4_isr
noexpand
  endif
endif
ifdef vp5_bank
  if vp5_thread == 0
expand
		call	vp5_isr
noexpand
  endif
endif
ifdef vp6_bank
  if vp6_thread == 0
expand
		call	vp6_isr
noexpand
  endif
endif
ifdef vp7_bank
  if vp7_thread == 0
expand
		call	vp7_isr
noexpand
  endif
endif
if THREADS > 1
expand
		jmp	do_thread	;execute threaded code
noexpand
_lib_make_isr_thread	0
_lib_make_isr_thread	1
endif
if THREADS > 2
_lib_make_isr_thread	2
_lib_make_isr_thread	3
endif
if THREADS > 4
_lib_make_isr_thread	4
_lib_make_isr_thread	5
_lib_make_isr_thread	6
_lib_make_isr_thread	7
endif
if THREADS > 8
_lib_make_isr_thread	8
_lib_make_isr_thread	9
_lib_make_isr_thread	10
_lib_make_isr_thread	11
_lib_make_isr_thread	12
_lib_make_isr_thread	13
_lib_make_isr_thread	14
_lib_make_isr_thread	15
endif
expand
isr_thread_end
noexpand
ifdef vp8_bank
  if vp8_thread == 0
expand
		call	vp8_isr
noexpand
  endif
endif
ifdef vp9_bank
  if vp9_thread == 0
expand
		call	vp9_isr
noexpand
  endif
endif
ifdef vp10_bank
  if vp10_thread == 0
expand
		call	vp10_isr
noexpand
  endif
endif
ifdef vp11_bank
  if vp11_thread == 0
expand
		call	vp11_isr
noexpand
  endif
endif
ifdef vp12_bank
  if vp12_thread == 0
expand
		call	vp12_isr
noexpand
  endif
endif
ifdef vp13_bank
  if vp13_thread == 0
expand
		call	vp13_isr
noexpand
  endif
endif
ifdef vp14_bank
  if vp14_thread == 0
expand
		call	vp14_isr
noexpand
  endif
endif
ifdef vp15_bank
  if vp15_thread == 0
expand
		call	vp15_isr
noexpand
  endif
endif
code		=	$
endm

;end of file lib_threads.inc
